﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="Tickets_327691_Default" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
</head>
<body>
    <form id="form1" runat="server">
    <asp:ScriptManager ID="ScriptManager1" runat="server">
    </asp:ScriptManager>
    <div>
        <input type="button" value="Extract edited item values" onclick="extractEditedValues()" />
        <telerik:RadGrid ID="RadGrid1" runat="server" Width="800px"
            OnNeedDataSource="RadGrid1_NeedDataSource" 
            AutoGenerateEditColumn="true"
            OnItemCreated="RadGrid1_ItemCreated">
            <MasterTableView EditMode="PopUp">
            </MasterTableView>
        </telerik:RadGrid>

        <script type="text/javascript">
            function extractEditedValues()
            {
                var grid = $find('<%= RadGrid1.ClientID %>');
                var master = grid.get_masterTableView();
                var items = master.get_dataItems();
                if (grid._editIndexes.length > 0)
                {
                    var editIndex = parseInt(grid._editIndexes[0], 10);
                    var editedItem = items[editIndex];
                    var editForm = getEditForm(editedItem);
                    //var inputValues = getInputValues(editForm);
                    var editors = getEditors(editForm);

                    var msg = [];
                    for (var i = 0; i < editors.length; i++)
                    {
                        msg.push(i + ":  ")
                        msg.push("ColumName: " + editors[i].columnName + "\r\n");
                        msg.push("      Input: " + (editors[i].input.id || editors[i].input._element.id) + "\r\n");
                        msg.push("      Value: " + editors[i].value + "\r\n");
                    }

                    alert(msg.join(""));
                }
            }

            function getEditForm(editItem)
            {
                var nextRow = editItem.get_element().nextSibling;
                if (nextRow.className !== "")
                {
                    return editItem;
                }

                if (document.getElementsByClassName)
                {
                    return nextRow.getElementsByClassName("rgEditForm")[0];
                }
                else
                {
                    var divs = nextRow.getElementsByTagName("div");
                    for (var i = 0; i < divs.length; i++)
                    {
                        if (divs[i].className.indexOf("rgEditForm") > -1)
                        {
                            return divs[i];
                        }
                    }
                }

                return null;
            }

            function getEditors(editForm)
            {
                var inputs = editForm.getElementsByTagName("input");
                var editors = [];

                for (var i = 0; i < inputs.length; i++)
                {
                    var input = inputs[i];
                    var columnName = ""
                    var value = null;

                    if (input.type === "text")
                    {
                        if (input.className === "")
                        {
                            columnName = getColumnName(input);
                            value = input.value;
                        }
                        else if (input.className.indexOf("riTextBox") > -1)
                        {
                            columnName = getColumnName(input);
                            var inputControl = $find(input.id.substr(0, input.id.length - 5));
                            value = inputControl.get_value();
                        }
                    }
                    else if (input.type === "checkbox")
                    {
                        columnName = getColumnName(input);
                        value = input.checked;
                    }

                    if (columnName)
                    {
                        editors[editors.length] = { columnName: columnName, input: input, value: value };
                    }
                }

                return editors;
            }

//            function getInputValues(editForm)
//            {
//                var inputs = editForm.getElementsByTagName("input");
//                var values = {};
//                for (var i = 0; i < inputs.length; i++)
//                {
//                    var input = inputs[i];
//                    var columnName = ""
//                    var value = null;
//                    
//                    if (input.type === "text")
//                    {
//                        if (input.className === "")
//                        {
//                            columnName = getColumnName(input);
//                            value = input.value;
//                        }
//                        else if (input.className.indexOf("riTextBox") > -1)
//                        {
//                            columnName = getColumnName(input);
//                            var inputControl = $find(input.id.substr(0, input.id.length - 5));
//                            value = inputControl.get_value();
//                        }
//                    }
//                    else if (input.type === "checkbox")
//                    {
//                        columnName = getColumnName(input);
//                        value = input.checked;
//                    }

//                    if (columnName)
//                    {
//                        values[columnName] = value;
//                    }
//                }

//                return values;
//            }

            function getColumnName(input)
            {
                var label = null;
                if (input.className.indexOf("riTextBox") > -1)
                {
                    var inputControl = $find(input.id.substr(0, input.id.length - 5));
                    var cell = null;
                    
                    if (inputControl.Owner)
                    {
                        cell = inputControl.Owner.get_element().parentNode.parentNode;
                    }
                    else
                    {
                        cell = inputControl.get_element().parentNode.parentNode;
                    }
                    
                    label = cell.previousSibling.getElementsByTagName("label")[0];
                }
                else
                {
                    label = input.parentNode.previousSibling.getElementsByTagName("label")[0];
                }
                                
                return label.innerHTML.substr(0, label.innerHTML.length - 1);
            }
        </script>
    </div>
    </form>
</body>
</html>
